import React, { useEffect, useState } from 'react';
import { AppContext } from './AppContext';

const ContextProvider = AppContext.Provider;

const storedCalories = JSON.parse(localStorage.getItem('calorieItems') || '[]');

function AppContextProvider (props: object) {
  const [calorieItems, setCalorieItems] = useState<CalorieItems>(storedCalories);
  const [selectedDate, setSelectedDate] = useState<number>(Date.now());
  const [selectedItem, setSelectedItem] = useState<CalorieValue>();

  useEffect(() => {
    localStorage.setItem('calorieItems', JSON.stringify(calorieItems));
  });

  return (
    <ContextProvider value={{
      calorieItems,
      selectedDate,
      selectedItem,
      setCalorieItems,
      setSelectedDate,
      setSelectedItem
    }} {...props} />
  );
}

export {
  AppContextProvider
};
